import Combine
import Foundation

enum MeetupId {
  enum Keys: String, RawRepresentable {
    case meetupIdTextApp
    case meetupIdTextUI
  }

  static func shouldFormat(_ s: String) -> String? {
      let digits = s.components(separatedBy: NSCharacterSet.decimalDigits.inverted).reduce("") { $0 + $1 }
      var r = ""
      var i = 0
      for v in digits {
          r += String(v)
          i = i + 1
          if i % 3 == 0 {
              r += "-"
          }
      }
      if r.hasSuffix("-") {
          r = String(r.dropLast(1))
      }
      return r
  }

  final class MeetupIdFormatter {
      var subscriptions = Set<AnyCancellable>()

      deinit {
          /**/print("ИГР MeetupIF.DEinit")
      }

      init() {
          Bus.processSync(
            &subscriptions,
            Keys.meetupIdTextUI.rawValue,
            Keys.meetupIdTextApp.rawValue,
            shouldFormat
          )
          /**/print("ИГР MeetupIF.init")
      }
  }
}
